blob: 8b9058971767dbb4d94e996876f6ba7ed178ddd6 [file] [log] [blame]
Lars Hjemli70c7ac22007-05-26 15:56:40 +02001#!/bin/sh
2#
Sven Verdoolaegeecda0722007-06-24 23:06:07 +02003# git-submodules.sh: add, init, update or list git submodules
Lars Hjemli70c7ac22007-05-26 15:56:40 +02004#
5# Copyright (c) 2007 Lars Hjemli
6
Johan Herland1d5bec82009-08-19 03:45:19 +02007dashless=$(basename "$0" | sed -e 's/-/ /')
Jens Lehmannd27b8762010-07-17 17:11:43 +02008USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
Johan Herland64b19ff2009-08-19 03:45:24 +02009 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
Johan Herland1d5bec82009-08-19 03:45:19 +020010 or: $dashless [--quiet] init [--] [<path>...]
Johan Herlandb13fd5c2009-08-19 03:45:23 +020011 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
Junio C Hamanoadc54232009-08-27 16:59:25 -070012 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
Johan Herland15fc56a2009-08-19 03:45:22 +020013 or: $dashless [--quiet] foreach [--recursive] <command>
Johan Herland1d5bec82009-08-19 03:45:19 +020014 or: $dashless [--quiet] sync [--] [<path>...]"
Junio C Hamano8f321a32007-11-06 01:50:02 -080015OPTIONS_SPEC=
Lars Hjemli70c7ac22007-05-26 15:56:40 +020016. git-sh-setup
Mark Levedahl98fcf842008-08-24 14:46:10 -040017. git-parse-remote
Lars Hjemli70c7ac22007-05-26 15:56:40 +020018require_work_tree
19
Junio C Hamano5c08dbb2008-01-15 02:48:45 -080020command=
Sven Verdoolaegeecda0722007-06-24 23:06:07 +020021branch=
Jens Lehmannd27b8762010-07-17 17:11:43 +020022force=
Michael S. Tsirkind92a3952009-05-04 22:30:01 +030023reference=
Lars Hjemli70c7ac22007-05-26 15:56:40 +020024cached=
Gerrit Pape48bb3032010-04-26 11:50:39 +020025recursive=
26init=
Jens Lehmann1c244f62009-08-13 21:32:50 +020027files=
Fabian Franz31ca3ac2009-02-05 20:18:32 -020028nofetch=
Johan Herland32948422009-06-03 08:27:06 +020029update=
Johan Herland15fc56a2009-08-19 03:45:22 +020030prefix=
Lars Hjemli70c7ac22007-05-26 15:56:40 +020031
Mark Levedahlf31a5222007-09-23 22:19:42 -040032# Resolve relative url by appending to parent's url
33resolve_relative_url ()
34{
Mark Levedahl98fcf842008-08-24 14:46:10 -040035 remote=$(get_default_remote)
Mark Levedahl8e7e6f32008-06-14 13:09:41 -040036 remoteurl=$(git config "remote.$remote.url") ||
37 die "remote ($remote) does not have a url defined in .git/config"
Mark Levedahlf31a5222007-09-23 22:19:42 -040038 url="$1"
Mark Levedahl99b120a2008-08-21 19:54:01 -040039 remoteurl=${remoteurl%/}
Thomas Rastea640cc2011-01-10 11:37:26 +010040 sep=/
Mark Levedahlf31a5222007-09-23 22:19:42 -040041 while test -n "$url"
42 do
43 case "$url" in
44 ../*)
45 url="${url#../}"
Thomas Rastea640cc2011-01-10 11:37:26 +010046 case "$remoteurl" in
47 */*)
48 remoteurl="${remoteurl%/*}"
49 ;;
50 *:*)
51 remoteurl="${remoteurl%:*}"
52 sep=:
53 ;;
54 *)
55 die "cannot strip one component off url '$remoteurl'"
56 ;;
57 esac
Mark Levedahlf31a5222007-09-23 22:19:42 -040058 ;;
59 ./*)
60 url="${url#./}"
61 ;;
62 *)
63 break;;
64 esac
65 done
Thomas Rastea640cc2011-01-10 11:37:26 +010066 echo "$remoteurl$sep${url%/}"
Mark Levedahlf31a5222007-09-23 22:19:42 -040067}
68
Lars Hjemli941987a2007-06-11 21:12:24 +020069#
David Aguilara7b32692008-08-22 00:30:50 -070070# Get submodule info for registered submodules
71# $@ = path to limit submodule list
72#
73module_list()
74{
Junio C Hamanoe1622bf2009-11-23 15:56:32 -080075 git ls-files --error-unmatch --stage -- "$@" | sane_grep '^160000 '
David Aguilara7b32692008-08-22 00:30:50 -070076}
77
78#
Lars Hjemli941987a2007-06-11 21:12:24 +020079# Map submodule path to submodule name
80#
81# $1 = path
82#
83module_name()
84{
Junio C Hamano537601a2007-07-25 15:51:26 -070085 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
Chris Riddfe22e542008-06-11 14:09:19 +010086 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
Imran M Yousufa5099bb2008-05-15 13:42:58 +060087 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
Junio C Hamano537601a2007-07-25 15:51:26 -070088 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
Lars Hjemli941987a2007-06-11 21:12:24 +020089 test -z "$name" &&
90 die "No submodule mapping found in .gitmodules for path '$path'"
91 echo "$name"
92}
Lars Hjemli33aa6ff2007-06-06 11:13:01 +020093
94#
95# Clone a submodule
96#
Junio C Hamano23a485e2008-01-15 02:35:49 -080097# Prior to calling, cmd_update checks that a possibly existing
Sven Verdoolaegeecda0722007-06-24 23:06:07 +020098# path is not a git repository.
Junio C Hamano23a485e2008-01-15 02:35:49 -080099# Likewise, cmd_add checks that path does not exist at all,
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200100# since it is the location of a new submodule.
101#
Lars Hjemli33aa6ff2007-06-06 11:13:01 +0200102module_clone()
103{
104 path=$1
105 url=$2
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300106 reference="$3"
Lars Hjemli33aa6ff2007-06-06 11:13:01 +0200107
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300108 if test -n "$reference"
109 then
110 git-clone "$reference" -n "$url" "$path"
111 else
112 git-clone -n "$url" "$path"
113 fi ||
Lars Hjemli941987a2007-06-11 21:12:24 +0200114 die "Clone of '$url' into submodule path '$path' failed"
Lars Hjemli33aa6ff2007-06-06 11:13:01 +0200115}
116
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200117#
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200118# Add a new submodule to the working tree, .gitmodules and the index
119#
Mark Levedahlec05df32008-07-09 21:05:40 -0400120# $@ = repo path
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200121#
122# optional branch is stored in global branch variable
123#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800124cmd_add()
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200125{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800126 # parse $args after "submodule ... add".
127 while test $# -ne 0
128 do
129 case "$1" in
130 -b | --branch)
131 case "$2" in '') usage ;; esac
132 branch=$2
133 shift
134 ;;
Jens Lehmannd27b8762010-07-17 17:11:43 +0200135 -f | --force)
136 force=$1
137 ;;
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800138 -q|--quiet)
Stephen Boyd2e6a30e2009-06-16 15:33:00 -0700139 GIT_QUIET=1
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800140 ;;
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300141 --reference)
142 case "$2" in '') usage ;; esac
143 reference="--reference=$2"
144 shift
145 ;;
146 --reference=*)
147 reference="$1"
148 shift
149 ;;
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800150 --)
151 shift
152 break
153 ;;
154 -*)
155 usage
156 ;;
157 *)
158 break
159 ;;
160 esac
161 shift
162 done
163
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200164 repo=$1
165 path=$2
166
Jens Lehmann1414e572009-09-22 17:10:12 +0200167 if test -z "$path"; then
168 path=$(echo "$repo" |
169 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
170 fi
171
Mark Levedahlec05df32008-07-09 21:05:40 -0400172 if test -z "$repo" -o -z "$path"; then
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200173 usage
174 fi
175
Mark Levedahlec05df32008-07-09 21:05:40 -0400176 # assure repo is absolute or relative to parent
177 case "$repo" in
178 ./*|../*)
179 # dereference source url relative to parent's url
180 realrepo=$(resolve_relative_url "$repo") || exit
181 ;;
182 *:*|/*)
183 # absolute url
184 realrepo=$repo
185 ;;
186 *)
187 die "repo URL: '$repo' must be absolute or begin with ./|../"
188 ;;
189 esac
190
Michael J Gruberdb75ada2009-03-03 16:08:21 +0100191 # normalize path:
192 # multiple //; leading ./; /./; /../; trailing /
193 path=$(printf '%s/\n' "$path" |
194 sed -e '
195 s|//*|/|g
196 s|^\(\./\)*||
197 s|/\./|/|g
198 :start
199 s|\([^/]*\)/\.\./||
200 tstart
201 s|/*$||
202 ')
Junio C Hamano5be60072007-07-02 22:52:14 -0700203 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200204 die "'$path' already exists in the index"
205
Jens Lehmannd27b8762010-07-17 17:11:43 +0200206 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
207 then
208 echo >&2 "The following path is ignored by one of your .gitignore files:" &&
209 echo >&2 $path &&
210 echo >&2 "Use -f if you really want to add it."
211 exit 1
212 fi
213
Mark Levedahld4264ca2008-03-04 20:15:02 -0500214 # perhaps the path exists and is already a git repo, else clone it
215 if test -e "$path"
216 then
Mark Levedahle9656472008-07-07 22:36:40 -0400217 if test -d "$path"/.git -o -f "$path"/.git
Mark Levedahld4264ca2008-03-04 20:15:02 -0500218 then
219 echo "Adding existing repo at '$path' to the index"
220 else
221 die "'$path' already exists and is not a valid git repo"
222 fi
Mark Levedahlc2f93912008-07-09 21:05:41 -0400223
224 case "$repo" in
225 ./*|../*)
226 url=$(resolve_relative_url "$repo") || exit
227 ;;
228 *)
229 url="$repo"
230 ;;
231 esac
232 git config submodule."$path".url "$url"
Mark Levedahld4264ca2008-03-04 20:15:02 -0500233 else
Mark Levedahld4264ca2008-03-04 20:15:02 -0500234
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300235 module_clone "$path" "$realrepo" "$reference" || exit
Ben Jacksonea10b602009-04-18 20:42:07 -0700236 (
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100237 clear_local_git_env
Ben Jacksonea10b602009-04-18 20:42:07 -0700238 cd "$path" &&
239 # ash fails to wordsplit ${branch:+-b "$branch"...}
240 case "$branch" in
241 '') git checkout -f -q ;;
Jonathan Nieder502dc5b2010-12-01 12:50:46 -0600242 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
Ben Jacksonea10b602009-04-18 20:42:07 -0700243 esac
244 ) || die "Unable to checkout submodule '$path'"
Mark Levedahld4264ca2008-03-04 20:15:02 -0500245 fi
246
Jens Lehmannd27b8762010-07-17 17:11:43 +0200247 git add $force "$path" ||
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200248 die "Failed to add submodule '$path'"
249
Imran M Yousufa5099bb2008-05-15 13:42:58 +0600250 git config -f .gitmodules submodule."$path".path "$path" &&
251 git config -f .gitmodules submodule."$path".url "$repo" &&
Ævar Arnfjörð Bjarmason31991b02010-07-05 17:33:03 +0000252 git add --force .gitmodules ||
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200253 die "Failed to register submodule '$path'"
254}
255
256#
Mark Levedahl19a31f92008-08-10 19:10:04 -0400257# Execute an arbitrary command sequence in each checked out
258# submodule
259#
260# $@ = command to execute
261#
262cmd_foreach()
263{
Johan Herland1d5bec82009-08-19 03:45:19 +0200264 # parse $args after "submodule ... foreach".
265 while test $# -ne 0
266 do
267 case "$1" in
268 -q|--quiet)
269 GIT_QUIET=1
270 ;;
Johan Herland15fc56a2009-08-19 03:45:22 +0200271 --recursive)
272 recursive=1
273 ;;
Johan Herland1d5bec82009-08-19 03:45:19 +0200274 -*)
275 usage
276 ;;
277 *)
278 break
279 ;;
280 esac
281 shift
282 done
283
Ævar Arnfjörð Bjarmasonf030c962010-05-21 16:10:10 +0000284 toplevel=$(pwd)
285
David Aguilara7b32692008-08-22 00:30:50 -0700286 module_list |
Mark Levedahl19a31f92008-08-10 19:10:04 -0400287 while read mode sha1 stage path
288 do
289 if test -e "$path"/.git
290 then
Johan Herland15fc56a2009-08-19 03:45:22 +0200291 say "Entering '$prefix$path'"
Johan Herland1e7f2aa2009-08-16 03:10:08 +0200292 name=$(module_name "$path")
Johan Herland15fc56a2009-08-19 03:45:22 +0200293 (
294 prefix="$prefix$path/"
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100295 clear_local_git_env
Johan Herland15fc56a2009-08-19 03:45:22 +0200296 cd "$path" &&
297 eval "$@" &&
298 if test -n "$recursive"
299 then
300 cmd_foreach "--recursive" "$@"
301 fi
302 ) ||
Mark Levedahl19a31f92008-08-10 19:10:04 -0400303 die "Stopping at '$path'; script returned non-zero status."
304 fi
305 done
306}
307
308#
Lars Hjemli211b7f12007-06-06 11:13:02 +0200309# Register submodules in .git/config
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200310#
311# $@ = requested paths (default to all)
312#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800313cmd_init()
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200314{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800315 # parse $args after "submodule ... init".
316 while test $# -ne 0
317 do
318 case "$1" in
319 -q|--quiet)
Stephen Boyd2e6a30e2009-06-16 15:33:00 -0700320 GIT_QUIET=1
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800321 ;;
322 --)
323 shift
324 break
325 ;;
326 -*)
327 usage
328 ;;
329 *)
330 break
331 ;;
332 esac
333 shift
334 done
335
David Aguilara7b32692008-08-22 00:30:50 -0700336 module_list "$@" |
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200337 while read mode sha1 stage path
338 do
Lars Hjemli211b7f12007-06-06 11:13:02 +0200339 # Skip already registered paths
Lars Hjemli941987a2007-06-11 21:12:24 +0200340 name=$(module_name "$path") || exit
Junio C Hamano5be60072007-07-02 22:52:14 -0700341 url=$(git config submodule."$name".url)
Lars Hjemli211b7f12007-06-06 11:13:02 +0200342 test -z "$url" || continue
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200343
Imran M Yousufa5099bb2008-05-15 13:42:58 +0600344 url=$(git config -f .gitmodules submodule."$name".url)
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200345 test -z "$url" &&
Lars Hjemli941987a2007-06-11 21:12:24 +0200346 die "No url found for submodule path '$path' in .gitmodules"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200347
Mark Levedahlf31a5222007-09-23 22:19:42 -0400348 # Possibly a url relative to parent
349 case "$url" in
350 ./*|../*)
Mark Levedahl8e7e6f32008-06-14 13:09:41 -0400351 url=$(resolve_relative_url "$url") || exit
Mark Levedahlf31a5222007-09-23 22:19:42 -0400352 ;;
353 esac
354
Junio C Hamano5be60072007-07-02 22:52:14 -0700355 git config submodule."$name".url "$url" ||
Lars Hjemli941987a2007-06-11 21:12:24 +0200356 die "Failed to register url for submodule path '$path'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200357
Johan Herland32948422009-06-03 08:27:06 +0200358 upd="$(git config -f .gitmodules submodule."$name".update)"
359 test -z "$upd" ||
360 git config submodule."$name".update "$upd" ||
361 die "Failed to register update mode for submodule path '$path'"
Peter Huttererca2cedb2009-04-24 09:06:38 +1000362
Lars Hjemli941987a2007-06-11 21:12:24 +0200363 say "Submodule '$name' ($url) registered for path '$path'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200364 done
365}
366
367#
Lars Hjemli211b7f12007-06-06 11:13:02 +0200368# Update each submodule path to correct revision, using clone and checkout as needed
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200369#
370# $@ = requested paths (default to all)
371#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800372cmd_update()
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200373{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800374 # parse $args after "submodule ... update".
Kevin Ballard98dbe632010-11-02 23:26:25 -0700375 orig_flags=
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800376 while test $# -ne 0
377 do
378 case "$1" in
379 -q|--quiet)
Stephen Boyd2e6a30e2009-06-16 15:33:00 -0700380 GIT_QUIET=1
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800381 ;;
Johannes Schindelinbe4d2c82008-05-16 11:23:03 +0100382 -i|--init)
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300383 init=1
Johannes Schindelinbe4d2c82008-05-16 11:23:03 +0100384 ;;
Fabian Franz31ca3ac2009-02-05 20:18:32 -0200385 -N|--no-fetch)
Fabian Franz31ca3ac2009-02-05 20:18:32 -0200386 nofetch=1
387 ;;
Peter Huttererca2cedb2009-04-24 09:06:38 +1000388 -r|--rebase)
Johan Herland32948422009-06-03 08:27:06 +0200389 update="rebase"
Peter Huttererca2cedb2009-04-24 09:06:38 +1000390 ;;
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300391 --reference)
392 case "$2" in '') usage ;; esac
393 reference="--reference=$2"
Kevin Ballard98dbe632010-11-02 23:26:25 -0700394 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
395 shift
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300396 ;;
397 --reference=*)
398 reference="$1"
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300399 ;;
Johan Herland42b49172009-06-03 00:59:12 +0200400 -m|--merge)
Johan Herland42b49172009-06-03 00:59:12 +0200401 update="merge"
402 ;;
Johan Herlandb13fd5c2009-08-19 03:45:23 +0200403 --recursive)
Johan Herlandb13fd5c2009-08-19 03:45:23 +0200404 recursive=1
405 ;;
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800406 --)
407 shift
408 break
409 ;;
410 -*)
411 usage
412 ;;
413 *)
414 break
415 ;;
416 esac
Kevin Ballard98dbe632010-11-02 23:26:25 -0700417 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
418 shift
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800419 done
420
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300421 if test -n "$init"
422 then
423 cmd_init "--" "$@" || return
424 fi
425
David Aguilara7b32692008-08-22 00:30:50 -0700426 module_list "$@" |
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200427 while read mode sha1 stage path
428 do
Lars Hjemli941987a2007-06-11 21:12:24 +0200429 name=$(module_name "$path") || exit
Junio C Hamano5be60072007-07-02 22:52:14 -0700430 url=$(git config submodule."$name".url)
Johan Herland32948422009-06-03 08:27:06 +0200431 update_module=$(git config submodule."$name".update)
Lars Hjemli211b7f12007-06-06 11:13:02 +0200432 if test -z "$url"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200433 then
434 # Only mention uninitialized submodules when its
435 # path have been specified
436 test "$#" != "0" &&
Alexandre Julliard989206f2008-11-11 22:09:16 +0100437 say "Submodule path '$path' not initialized" &&
Johannes Schindelinbe4d2c82008-05-16 11:23:03 +0100438 say "Maybe you want to use 'update --init'?"
Lars Hjemli211b7f12007-06-06 11:13:02 +0200439 continue
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200440 fi
Lars Hjemli211b7f12007-06-06 11:13:02 +0200441
Lars Hjemliba88a1f2008-02-20 23:13:15 +0100442 if ! test -d "$path"/.git -o -f "$path"/.git
Lars Hjemli211b7f12007-06-06 11:13:02 +0200443 then
Michael S. Tsirkind92a3952009-05-04 22:30:01 +0300444 module_clone "$path" "$url" "$reference"|| exit
Lars Hjemlibf2d8242007-06-11 21:12:22 +0200445 subsha1=
446 else
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100447 subsha1=$(clear_local_git_env; cd "$path" &&
Junio C Hamano5be60072007-07-02 22:52:14 -0700448 git rev-parse --verify HEAD) ||
Lars Hjemli941987a2007-06-11 21:12:24 +0200449 die "Unable to find current revision in submodule path '$path'"
Lars Hjemli211b7f12007-06-06 11:13:02 +0200450 fi
451
Johan Herland32948422009-06-03 08:27:06 +0200452 if ! test -z "$update"
Peter Huttererca2cedb2009-04-24 09:06:38 +1000453 then
Johan Herland32948422009-06-03 08:27:06 +0200454 update_module=$update
Peter Huttererca2cedb2009-04-24 09:06:38 +1000455 fi
456
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200457 if test "$subsha1" != "$sha1"
458 then
Ping Yinb9b378a2008-09-26 23:33:23 +0800459 force=
460 if test -z "$subsha1"
461 then
462 force="-f"
463 fi
Fabian Franz31ca3ac2009-02-05 20:18:32 -0200464
465 if test -z "$nofetch"
466 then
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100467 (clear_local_git_env; cd "$path" &&
Fabian Franz31ca3ac2009-02-05 20:18:32 -0200468 git-fetch) ||
469 die "Unable to fetch in submodule path '$path'"
470 fi
471
Johan Herland32948422009-06-03 08:27:06 +0200472 case "$update_module" in
473 rebase)
474 command="git rebase"
Peter Huttererca2cedb2009-04-24 09:06:38 +1000475 action="rebase"
476 msg="rebased onto"
Johan Herland32948422009-06-03 08:27:06 +0200477 ;;
Johan Herland42b49172009-06-03 00:59:12 +0200478 merge)
479 command="git merge"
480 action="merge"
481 msg="merged in"
482 ;;
Johan Herland32948422009-06-03 08:27:06 +0200483 *)
484 command="git checkout $force -q"
Peter Huttererca2cedb2009-04-24 09:06:38 +1000485 action="checkout"
486 msg="checked out"
Johan Herland32948422009-06-03 08:27:06 +0200487 ;;
488 esac
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200489
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100490 (clear_local_git_env; cd "$path" && $command "$sha1") ||
Peter Huttererca2cedb2009-04-24 09:06:38 +1000491 die "Unable to $action '$sha1' in submodule path '$path'"
492 say "Submodule path '$path': $msg '$sha1'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200493 fi
Johan Herlandb13fd5c2009-08-19 03:45:23 +0200494
495 if test -n "$recursive"
496 then
Kevin Ballard98dbe632010-11-02 23:26:25 -0700497 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags") ||
Johan Herlandb13fd5c2009-08-19 03:45:23 +0200498 die "Failed to recurse into submodule path '$path'"
499 fi
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200500 done
501}
502
Emil Medvebffe71f2007-06-26 18:40:58 -0500503set_name_rev () {
504 revname=$( (
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100505 clear_local_git_env
Emil Medvebffe71f2007-06-26 18:40:58 -0500506 cd "$1" && {
Junio C Hamano5be60072007-07-02 22:52:14 -0700507 git describe "$2" 2>/dev/null ||
508 git describe --tags "$2" 2>/dev/null ||
Mark Levedahlf669ac02008-04-14 22:48:06 -0400509 git describe --contains "$2" 2>/dev/null ||
510 git describe --all --always "$2"
Emil Medvebffe71f2007-06-26 18:40:58 -0500511 }
512 ) )
513 test -z "$revname" || revname=" ($revname)"
514}
Ping Yin28f9af52008-03-11 21:52:15 +0800515#
516# Show commit summary for submodules in index or working tree
517#
518# If '--cached' is given, show summary between index and given commit,
519# or between working tree and given commit
520#
521# $@ = [commit (default 'HEAD'),] requested paths (default all)
522#
523cmd_summary() {
Ping Yinf2dc06a2008-03-11 21:52:17 +0800524 summary_limit=-1
Ping Yind0f64dd2008-04-12 23:05:31 +0800525 for_status=
Jens Lehmann1c244f62009-08-13 21:32:50 +0200526 diff_cmd=diff-index
Emil Medvebffe71f2007-06-26 18:40:58 -0500527
Ping Yin28f9af52008-03-11 21:52:15 +0800528 # parse $args after "submodule ... summary".
529 while test $# -ne 0
530 do
531 case "$1" in
532 --cached)
533 cached="$1"
534 ;;
Jens Lehmann1c244f62009-08-13 21:32:50 +0200535 --files)
536 files="$1"
537 ;;
Ping Yind0f64dd2008-04-12 23:05:31 +0800538 --for-status)
539 for_status="$1"
540 ;;
Ping Yinf2dc06a2008-03-11 21:52:17 +0800541 -n|--summary-limit)
542 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
543 then
544 :
545 else
546 usage
547 fi
548 shift
549 ;;
Ping Yin28f9af52008-03-11 21:52:15 +0800550 --)
551 shift
552 break
553 ;;
554 -*)
555 usage
556 ;;
557 *)
558 break
559 ;;
560 esac
561 shift
562 done
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200563
Ping Yinf2dc06a2008-03-11 21:52:17 +0800564 test $summary_limit = 0 && return
565
Johan Herland3deea892010-02-16 11:21:14 +0100566 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
Ping Yin28f9af52008-03-11 21:52:15 +0800567 then
568 head=$rev
Jeff Kingcaa9c3c2010-03-03 14:19:09 -0800569 test $# = 0 || shift
Johan Herland3deea892010-02-16 11:21:14 +0100570 elif test -z "$1" -o "$1" = "HEAD"
571 then
Junio C Hamano14e940d2010-03-03 14:19:10 -0800572 # before the first commit: compare with an empty tree
573 head=$(git hash-object -w -t tree --stdin </dev/null)
Jens Lehmann2ea6c2c2010-03-09 15:55:32 +0100574 test -z "$1" || shift
Ping Yin28f9af52008-03-11 21:52:15 +0800575 else
Johan Herland3deea892010-02-16 11:21:14 +0100576 head="HEAD"
Ping Yin28f9af52008-03-11 21:52:15 +0800577 fi
578
Jens Lehmann1c244f62009-08-13 21:32:50 +0200579 if [ -n "$files" ]
580 then
581 test -n "$cached" &&
582 die "--cached cannot be used with --files"
583 diff_cmd=diff-files
584 head=
585 fi
586
Ping Yin28f9af52008-03-11 21:52:15 +0800587 cd_to_toplevel
588 # Get modified modules cared by user
Jens Lehmann18076502010-06-25 16:56:02 +0200589 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
Junio C Hamanoe1622bf2009-11-23 15:56:32 -0800590 sane_egrep '^:([0-7]* )?160000' |
Ping Yin28f9af52008-03-11 21:52:15 +0800591 while read mod_src mod_dst sha1_src sha1_dst status name
592 do
593 # Always show modules deleted or type-changed (blob<->module)
594 test $status = D -o $status = T && echo "$name" && continue
595 # Also show added or modified modules which are checked out
596 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
597 echo "$name"
598 done
599 )
Ping Yin1cb639e2008-03-11 21:52:16 +0800600
Ping Yind0f64dd2008-04-12 23:05:31 +0800601 test -z "$modules" && return
602
Jens Lehmann18076502010-06-25 16:56:02 +0200603 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
Junio C Hamanoe1622bf2009-11-23 15:56:32 -0800604 sane_egrep '^:([0-7]* )?160000' |
Ping Yin1cb639e2008-03-11 21:52:16 +0800605 cut -c2- |
606 while read mod_src mod_dst sha1_src sha1_dst status name
607 do
608 if test -z "$cached" &&
609 test $sha1_dst = 0000000000000000000000000000000000000000
610 then
611 case "$mod_dst" in
612 160000)
613 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
614 ;;
615 100644 | 100755 | 120000)
616 sha1_dst=$(git hash-object $name)
617 ;;
618 000000)
619 ;; # removed
620 *)
621 # unexpected type
622 echo >&2 "unexpected mode $mod_dst"
623 continue ;;
624 esac
625 fi
626 missing_src=
627 missing_dst=
628
629 test $mod_src = 160000 &&
Miklos Vajna30353a42008-12-03 14:26:52 +0100630 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
Ping Yin1cb639e2008-03-11 21:52:16 +0800631 missing_src=t
632
633 test $mod_dst = 160000 &&
Miklos Vajna30353a42008-12-03 14:26:52 +0100634 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
Ping Yin1cb639e2008-03-11 21:52:16 +0800635 missing_dst=t
636
637 total_commits=
638 case "$missing_src,$missing_dst" in
639 t,)
640 errmsg=" Warn: $name doesn't contain commit $sha1_src"
641 ;;
642 ,t)
643 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
644 ;;
645 t,t)
646 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
647 ;;
648 *)
649 errmsg=
650 total_commits=$(
651 if test $mod_src = 160000 -a $mod_dst = 160000
652 then
653 range="$sha1_src...$sha1_dst"
654 elif test $mod_src = 160000
655 then
656 range=$sha1_src
657 else
658 range=$sha1_dst
659 fi
660 GIT_DIR="$name/.git" \
Jeff Kingb0e621a2010-04-08 15:42:37 -0400661 git rev-list --first-parent $range -- | wc -l
Ping Yin1cb639e2008-03-11 21:52:16 +0800662 )
Johannes Sixteed35592008-03-12 09:30:01 +0100663 total_commits=" ($(($total_commits + 0)))"
Ping Yin1cb639e2008-03-11 21:52:16 +0800664 ;;
665 esac
666
667 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
668 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
669 if test $status = T
670 then
671 if test $mod_dst = 160000
672 then
673 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
674 else
675 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
676 fi
677 else
678 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
679 fi
680 if test -n "$errmsg"
681 then
682 # Don't give error msg for modification whose dst is not submodule
683 # i.e. deleted or changed to blob
684 test $mod_dst = 160000 && echo "$errmsg"
685 else
686 if test $mod_src = 160000 -a $mod_dst = 160000
687 then
Ping Yinf2dc06a2008-03-11 21:52:17 +0800688 limit=
689 test $summary_limit -gt 0 && limit="-$summary_limit"
Ping Yin1cb639e2008-03-11 21:52:16 +0800690 GIT_DIR="$name/.git" \
Ping Yinf2dc06a2008-03-11 21:52:17 +0800691 git log $limit --pretty='format: %m %s' \
Ping Yin1cb639e2008-03-11 21:52:16 +0800692 --first-parent $sha1_src...$sha1_dst
693 elif test $mod_dst = 160000
694 then
695 GIT_DIR="$name/.git" \
696 git log --pretty='format: > %s' -1 $sha1_dst
697 else
698 GIT_DIR="$name/.git" \
699 git log --pretty='format: < %s' -1 $sha1_src
700 fi
701 echo
702 fi
703 echo
Ping Yind0f64dd2008-04-12 23:05:31 +0800704 done |
705 if test -n "$for_status"; then
Jens Lehmannf17a5d32010-01-17 20:42:31 +0100706 if [ -n "$files" ]; then
707 echo "# Submodules changed but not updated:"
708 else
709 echo "# Submodule changes to be committed:"
710 fi
Ping Yind0f64dd2008-04-12 23:05:31 +0800711 echo "#"
712 sed -e 's|^|# |' -e 's|^# $|#|'
713 else
714 cat
715 fi
Ping Yin28f9af52008-03-11 21:52:15 +0800716}
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200717#
Lars Hjemli941987a2007-06-11 21:12:24 +0200718# List all submodules, prefixed with:
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200719# - submodule not initialized
720# + different revision checked out
721#
722# If --cached was specified the revision in the index will be printed
723# instead of the currently checked out revision.
724#
725# $@ = requested paths (default to all)
726#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800727cmd_status()
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200728{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800729 # parse $args after "submodule ... status".
Kevin Ballard98dbe632010-11-02 23:26:25 -0700730 orig_flags=
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800731 while test $# -ne 0
732 do
733 case "$1" in
734 -q|--quiet)
Stephen Boyd2e6a30e2009-06-16 15:33:00 -0700735 GIT_QUIET=1
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800736 ;;
737 --cached)
738 cached=1
739 ;;
Johan Herland64b19ff2009-08-19 03:45:24 +0200740 --recursive)
741 recursive=1
742 ;;
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800743 --)
744 shift
745 break
746 ;;
747 -*)
748 usage
749 ;;
750 *)
751 break
752 ;;
753 esac
Kevin Ballard98dbe632010-11-02 23:26:25 -0700754 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800755 shift
756 done
757
David Aguilara7b32692008-08-22 00:30:50 -0700758 module_list "$@" |
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200759 while read mode sha1 stage path
760 do
Lars Hjemli941987a2007-06-11 21:12:24 +0200761 name=$(module_name "$path") || exit
Junio C Hamano5be60072007-07-02 22:52:14 -0700762 url=$(git config submodule."$name".url)
Johan Herland64b19ff2009-08-19 03:45:24 +0200763 displaypath="$prefix$path"
Lars Hjemliba88a1f2008-02-20 23:13:15 +0100764 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200765 then
Johan Herland64b19ff2009-08-19 03:45:24 +0200766 say "-$sha1 $displaypath"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200767 continue;
768 fi
CJ van den Berg41c7c1b2007-07-04 18:22:14 +0200769 set_name_rev "$path" "$sha1"
Jens Lehmann18076502010-06-25 16:56:02 +0200770 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200771 then
Johan Herland64b19ff2009-08-19 03:45:24 +0200772 say " $sha1 $displaypath$revname"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200773 else
774 if test -z "$cached"
775 then
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100776 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
CJ van den Berg41c7c1b2007-07-04 18:22:14 +0200777 set_name_rev "$path" "$sha1"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200778 fi
Johan Herland64b19ff2009-08-19 03:45:24 +0200779 say "+$sha1 $displaypath$revname"
780 fi
781
782 if test -n "$recursive"
783 then
784 (
785 prefix="$displaypath/"
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100786 clear_local_git_env
Johan Herland64b19ff2009-08-19 03:45:24 +0200787 cd "$path" &&
Kevin Ballarda7eff1a2010-11-02 23:26:24 -0700788 eval cmd_status "$orig_args"
Johan Herland64b19ff2009-08-19 03:45:24 +0200789 ) ||
790 die "Failed to recurse into submodule path '$path'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200791 fi
792 done
793}
David Aguilar2327f612008-08-24 12:43:37 -0700794#
795# Sync remote urls for submodules
796# This makes the value for remote.$remote.url match the value
797# specified in .gitmodules.
798#
799cmd_sync()
800{
801 while test $# -ne 0
802 do
803 case "$1" in
804 -q|--quiet)
Stephen Boyd2e6a30e2009-06-16 15:33:00 -0700805 GIT_QUIET=1
David Aguilar2327f612008-08-24 12:43:37 -0700806 shift
807 ;;
808 --)
809 shift
810 break
811 ;;
812 -*)
813 usage
814 ;;
815 *)
816 break
817 ;;
818 esac
819 done
820 cd_to_toplevel
821 module_list "$@" |
822 while read mode sha1 stage path
823 do
824 name=$(module_name "$path")
825 url=$(git config -f .gitmodules --get submodule."$name".url)
Johan Herlandbaede9f2008-09-22 18:08:31 +0200826
827 # Possibly a url relative to parent
828 case "$url" in
829 ./*|../*)
830 url=$(resolve_relative_url "$url") || exit
831 ;;
832 esac
833
Andreas Köhler33f072f2010-10-08 03:07:48 +0200834 say "Synchronizing submodule url for '$name'"
835 git config submodule."$name".url "$url"
836
David Aguilar2327f612008-08-24 12:43:37 -0700837 if test -e "$path"/.git
838 then
839 (
Giuseppe Bilotta74ae1412010-02-25 00:34:17 +0100840 clear_local_git_env
David Aguilar2327f612008-08-24 12:43:37 -0700841 cd "$path"
842 remote=$(get_default_remote)
David Aguilar2327f612008-08-24 12:43:37 -0700843 git config remote."$remote".url "$url"
844 )
845 fi
846 done
847}
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200848
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800849# This loop parses the command line arguments to find the
850# subcommand name to dispatch. Parsing of the subcommand specific
851# options are primarily done by the subcommand implementations.
852# Subcommand specific options such as --branch and --cached are
853# parsed here as well, for backward compatibility.
854
855while test $# != 0 && test -z "$command"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200856do
857 case "$1" in
David Aguilar2327f612008-08-24 12:43:37 -0700858 add | foreach | init | update | status | summary | sync)
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800859 command=$1
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200860 ;;
861 -q|--quiet)
Stephen Boyd2e6a30e2009-06-16 15:33:00 -0700862 GIT_QUIET=1
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200863 ;;
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200864 -b|--branch)
865 case "$2" in
866 '')
867 usage
868 ;;
869 esac
870 branch="$2"; shift
871 ;;
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200872 --cached)
Ping Yin28f9af52008-03-11 21:52:15 +0800873 cached="$1"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200874 ;;
875 --)
876 break
877 ;;
878 -*)
879 usage
880 ;;
881 *)
882 break
883 ;;
884 esac
885 shift
886done
887
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800888# No command word defaults to "status"
889test -n "$command" || command=status
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200890
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800891# "-b branch" is accepted only by "add"
892if test -n "$branch" && test "$command" != add
893then
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200894 usage
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800895fi
896
Ping Yin28f9af52008-03-11 21:52:15 +0800897# "--cached" is accepted only by "status" and "summary"
898if test -n "$cached" && test "$command" != status -a "$command" != summary
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800899then
900 usage
901fi
902
903"cmd_$command" "$@"